/************************************************************************************
Copyright (C) 2002 footprints (footprints@lycos.it)
 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details: http://www.gnu.org/copyleft/gpl.html#SEC1
************************************************************************************/

#include<iostream>
#include<fstream>
#include<string>
using namespace std;

class File{
	string text;
public:
	char* name;
	int size;
	File(const char*);
	~File();
	void replace(string, string, int);
	void replace(string, string, string);
	void replace(string, string, string, string);
	void write();
};

File::File(const char* n)
{	
	name=new char[strlen(n)];
	strcpy(name,n);
	ifstream in(name);

	in.seekg(0, ios::end);
	size=in.tellg();

	char* bak=new char[strlen(name)+5];
	strcpy(bak,name);
	strcat(bak,"-bak");

	ofstream out(bak);
	in.seekg(0, ios::beg);
	out<<in.rdbuf();
	out.close();
	delete[] bak;

	char* buf=new char[size+1];
	in.seekg(0, ios::beg);
	in.read(buf,size);

	buf[size]='\0';
	text=string(buf);
	delete[] buf;
	in.close();
}

File::~File()
{
	delete[] name;
}

void File::replace(string text1, string text2 ,int pos)
{
	while((pos=text.find(text1,pos))>=0 && pos<size){
		text.erase(pos, text1.length());
		text.insert(pos, text2);
		size=size+text2.size()-text1.size();
	}
}

void File::replace(string text1, string text2 ,string fpos)
{
	int	pos=text.find(fpos,0);
	while((pos=text.find(text1,pos))>=0 && pos<size){
		text.erase(pos,text1.length());
		text.insert(pos, text2);
		size=size+text2.size()-text1.size();
	}
}

void File::replace(string text1, string text2 ,string start,string stop)
{
	int pos1=text.find(start,0);
	int pos2=text.find(stop,pos1);
	while((pos1=text.find(text1,pos1))>=0 && pos1<pos2){
		text.erase(pos1,text1.length());
		text.insert(pos1, text2);
		size=size+text2.size()-text1.size();
	}
}

void File::write()
{
	ofstream out(name);
	/*if(int diff=text.size()-size>0){
		char *temp=(char*)text.data();
		temp[size]='\0';
	}*/
	out<<text;
	out.close();
}

int main(int argv,char* argc[])
{
	string linux_dir("/");
	string win_dir("\\");
	win_dir=win_dir+string("\\");

	if(argv==5){
		string linux_root(argc[2]);
		string win_root(argc[1]);
		int p=0;
		while((p=win_root.find("\\",p))>=0 && p<=win_root.length()){
			win_root.insert(p,"\\");
			p=p+2;
		}
		string param(argc[3]);

		string dir_panacea("panacea.dat");
		string dir_prefs("prefs.js");
		string win_brows("C%3A%5CPROGRA%7E1%5CMOZILLA.ORG%5CMOZILLA%5Csearchplugins%5C");
		string linux_brows("/usr/local/mozilla/searchplugins/");

		if(param==string("win")){
			dir_panacea=win_root+dir_panacea;
			dir_prefs=win_root+dir_prefs;
		}
		else if(param==string("linux")){
			dir_panacea=linux_root+dir_panacea;
			dir_prefs=linux_root+dir_prefs;
		}
		if(!strcmp(argc[4],"win")){
			{
				File panacea(dir_panacea.data());
				panacea.replace(linux_root, win_root, 0);

				string fpos("<(80");
				panacea.replace(linux_dir, win_dir, fpos);
				panacea.write();
			}
			{
				File prefs(dir_prefs.data());
				prefs.replace(linux_root, win_root, 0);
				string fpos=string("browser.cache.disk.parent_directory");
				string fpos1=string(");");
				prefs.replace(linux_root, win_root, fpos, fpos1);

				fpos=string("browser.search.defaultengine");
				fpos1=string(");");
				prefs.replace(linux_brows, win_brows, fpos, fpos1);

				fpos=string("mail.newsrc_root");
				prefs.replace(linux_root, win_root, fpos);
				prefs.replace(linux_dir, win_dir, fpos);

				prefs.write();
			}
			cout<<"Esportazione linux->windows terminata!"<<endl;
			return 0;
		}
		else if(!strcmp(argc[4],"linux")){
			{
				File panacea(dir_panacea.data());
				panacea.replace(win_root, linux_root, 0);

				string fpos("<(80");
				panacea.replace(win_dir, linux_dir, fpos);
				panacea.write();
			}
			{
				File prefs(dir_prefs.data());
				prefs.replace(win_root ,linux_root, 0);
				string fpos=string("browser.cache.disk.parent_directory");
				string fpos1=string(");");
				prefs.replace(win_root, linux_root, fpos, fpos1);
				string win_root1=win_root;
				win_root1.replace(win_root1.rfind("\\")-1,2,"");
				prefs.replace(win_root1, linux_root, fpos, fpos1);


				fpos=string("browser.search.defaultengine");
				fpos1=string(");");
				prefs.replace(win_brows, linux_brows, fpos, fpos1);

				fpos=string("mail.newsrc_root");
				prefs.replace(win_root, linux_root, fpos);
				prefs.replace(win_dir, linux_dir, fpos);

				prefs.write();
			}
			
			cout<<"Esportazione windows->linux terminata!"<<endl;	
			return 0;
		}
		else{
			cout<<"Parametro sconosciuto"<<endl;
			cout<<param<<endl;
			return 1;
		}
	}
	if(argv==2){
		string param(argc[1]);
		if(param==string("--help")){
			cout<<"Mozilla Export"<<endl;
			cout<<"Cambia i percorsi dei file di configurazione di Mozilla\n"<<
				"in modo da usare la stessa cartella per la versione di Windows e di Linux\n\n"<<
				"uso:\n"<<
				"\tmozexp [windir] [linuxdir] [ambiente] [modo]\n"<<
				"con:\n"<<
				"\t[windir]:\tpercorso completo della cartella windows di mozilla\n"<<
				"\t\t\t(es. d:\\documenti\\mozilla\\default\\asd6dhre.slt\\)\n"<<
				"\t[linuxdir]:\tpercorso completo della cartella linux di mozilla\n"<<
				"\t\t\t(es. /mnt/D/mozilla/default/asd6dhre.slt/)\n"<<
				"\t[ambiente]:\twin (windows), linux (linux)\n"<<
				"\t[modo]:\t\twin (da linux a windows), linux (da windows a linux)\n";
				
			return 1;
		}
		else{
			cout<<"Parametro sconosciuto"<<endl;
			cout<<param<<endl;
			return 1;
		}
	}
	else{
		cout<<"Numero di parametri errato!"<<endl;
		cout<<"Scrivi:"<<endl<<"\tmozexp --help"<<endl<<"per l'help"<<endl;
		return 1;
	}
}
